<template>
  <div>
    <section class="primary darken-4 mb-3 white--text py-5">
      <v-container>
        <div class="d-flex flex-column align-start flex-sm-row align-center">
          <v-avatar color="accent" rounded size="130" class="mr-5">
            <img alt="Avatar" :src="user.avatar">
          </v-avatar>
          <div class="py-3 text-center text-sm-left">
            <div class="text-h4">{{ user.firstName }} {{ user.lastName }}</div>
            <div class="text-h6">{{ user.job }}</div>
          </div>
        </div>
      </v-container>
    </section>

    <section>
      <v-container>
        <v-row>
          <h1 class="gray--text main-title">
          Quelles sont vos disponilibitées <b>{{ user.firstName }}</b> ?
          </h1>
        </v-row>
        <v-row>
          <v-col cols="12" sm="6">
            <v-btn small color="primary" block class="white--text py-5" @click="addAvail.dialog = true;">
              <v-icon class="mr-2" small>mdi-plus-circle</v-icon>
              Ajouter un créneau horraire
            </v-btn>
          </v-col>
          <v-col cols="12" sm="6">
            <v-btn small color="orange darken-5" block class="white--text py-5" @click="addUnavail.dialog = true;">
              <v-icon class="mr-2" small>mdi-plus-circle</v-icon>
              Ajouter une indisponibilité
            </v-btn>
          </v-col>
        </v-row>
        <v-row>
          <v-col cols="12" class="mt-5">
            <p class="font-italic grey--text darken-4 v-mid text-center">
              <v-icon small>mdi-information-variant</v-icon>
              Double-cliquez sur une disponibilité pour la supprimer !
            </p>
            <div id="disponibility-calendar">

              <div id="disponibility-calendar-header">
                <div class="disponibility-calendar-header-element">Lundi</div>
                <div class="disponibility-calendar-header-element">Mardi</div>
                <div class="disponibility-calendar-header-element">Mercredi</div>
                <div class="disponibility-calendar-header-element">Jeudi</div>
                <div class="disponibility-calendar-header-element">Vendredi</div>
                <div class="disponibility-calendar-header-element">Samedi</div>
                <div class="disponibility-calendar-header-element">Dimanche</div>
              </div>

              <div id="disponibility-calendar-container">
                <div class="disponibility-calendar-row" v-for="day in days" :key="day.value">

                  <v-skeleton-loader type="image" v-show="isLoading.availabilities" height="50" class="mb-4" ></v-skeleton-loader>
                  <v-skeleton-loader type="image" v-show="isLoading.availabilities" height="50" class="mb-4" ></v-skeleton-loader>
                  <v-skeleton-loader type="image" v-show="isLoading.availabilities" height="50" class="mb-4" ></v-skeleton-loader>
                  <v-skeleton-loader type="image" v-show="isLoading.availabilities" height="50" class="mb-4" ></v-skeleton-loader>
                  <v-skeleton-loader type="image" v-show="isLoading.availabilities" height="50" class="mb-4" ></v-skeleton-loader>

                  <v-badge offset-y="5px" offset-x="5px" v-for="(val, dispoId) in availabilities[day.value]" :key="dispoId"
                      bordered dot :color="generateOfficeColor(val.id_office)">
                    <div :class="'disponibility-calendar-element'" @dblclick="removeAvailability(val)" class="mb-4">
                      {{ val.hour_start.format('k:m') }}
                    </div>
                  </v-badge>
                </div>
              </div>
            </div>
          </v-col>
        </v-row>
        <v-col cols="12" class="align-center justify-center d-flex">

          <v-skeleton-loader v-show="isLoading.office && officesOnPlaced.length < 1" type="chip" class="mx-1"></v-skeleton-loader>
          <v-skeleton-loader v-show="isLoading.office && officesOnPlaced.length < 1" type="chip" class="mx-1"></v-skeleton-loader>
          <v-skeleton-loader v-show="isLoading.office && officesOnPlaced.length < 1" type="chip" class="mx-1"></v-skeleton-loader>

          <v-chip class="ma-2" v-for="office in validatedOffices" :key="office.value"
                  :style="'color: white; background-color: ' + generateOfficeColor(office.id)">
            {{ office.name }}
          </v-chip>
        </v-col>

        <v-row>
          <h1 class="gray--text main-title">
            Vos indisponibilités
          </h1>
        </v-row>

        <v-row>
          <v-col cols="12" sm="4" v-for="(unavail, index) in unavailabilities" :key="index">
            <v-card outlined>
              <v-list-item three-line>
                <v-list-item-content>
                  <div class="overline mb-4">{{ moment(unavail.start).format('dddd D MMMM') }}</div>
                  <v-list-item-subtitle>Du {{ moment(unavail.start).format('dddd D MMMM h:mm') }} au {{ moment(unavail.stop).format('dddd D MMMM h:mm') }}</v-list-item-subtitle>
                </v-list-item-content>
              </v-list-item>
              <v-card-actions>
                <v-btn text small color="red" @click="removeUnavailability(unavail)">Annuler ?</v-btn>
              </v-card-actions>
            </v-card>
          </v-col>
        </v-row>

      </v-container>
    </section>

    <v-dialog v-model="addAvail.dialog" persistent max-width="600px">
      <v-card>
        <v-card-title class="justify-center pt-5">
          <span class="headline mt-5">Ajouter des disponibilitées</span>
        </v-card-title>

        <v-card-text class="mt-5">
          <v-form v-model="addAvail.isValid">
            <v-select multiple chips filled persistent-hint v-model="addAvail.days" :items="days" item-value="value"
                      label="Jour(s) de la semaine" hint="Le créneau sera ajouté à tout les jours sélectionnés."
                      :rules="[$utils.rules.required]">
            </v-select>
            <v-dialog v-for='(date, index) in addAvail.times' :key='index'
                      :ref="'picker_' + index"
                      :close-on-content-click="false"
                      transition="scale-transition"
                      min-width="290px"
                      width="290px"
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                    v-model="addAvail.times[index]"
                    readonly required type="time" filled hide-details
                    hint="Ex. 14:30"
                    label="Début du créneau"
                    class="mt-1"
                    v-on="on"
                    :rules="[$utils.rules.required]"
                />
              </template>

              <v-time-picker full-width scrollable format="24hr"
                  v-model="addAvail.times[index]"
                  @click:minute="$refs['picker_' + index][0].save(date)"
              ></v-time-picker>
            </v-dialog>
            <div class="text-right mb-5 mt-2">
              <v-btn color="primary" outlined x-small @click="addTime">Ajouter un créneau</v-btn>
            </div>
            <v-select v-model="addAvail.office" :items="validatedOffices" item-value="id" item-text="name"
                      label="Agence" filled :rules="[$utils.rules.required]">
            </v-select>
          </v-form>
        </v-card-text>

        <v-divider></v-divider>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="gray darken-4" text @click="addAvail.dialog = false">
            Fermer
          </v-btn>
          <v-btn color="primary darken-1" text @click="addAvailability" :loading="addAvail.loading" :disabled="addAvail.loading || !addAvail.isValid">
            Ajouter
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog v-model="addUnavail.dialog" persistent max-width="600px">
      <v-card>
        <v-card-title class="pt-5 justify-center">
          <span class="headline mt-5">Ajouter des indisponibilités</span>
        </v-card-title>
        <v-card-text class="mt-5">
          <v-form v-model="addUnavail.isValid">
            <v-row>
              <v-col cols="12" sm="6">
                <v-menu v-model="addUnavail.start.date.picker" min-width="290px" width="290px" :close-on-content-click="false" transition="scale-transition">
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                        v-model="addUnavail.start.date.value" label="Date de début" :rules="[$utils.rules.required]"
                        v-bind="attrs" v-on="on"  readonly required type="date" filled hide-details offset-y
                    ></v-text-field>
                  </template>
                  <v-date-picker v-model="addUnavail.start.date.value" @input="addUnavail.start.date.picker = false" />
                </v-menu>
                <br>
                <v-menu v-model="addUnavail.end.date.picker" min-width="290px" width="290px" :close-on-content-click="false" transition="scale-transition">
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                        v-model="addUnavail.end.date.value" label="Date de fin" :rules="[$utils.rules.required]"
                        v-bind="attrs" v-on="on" readonly required type="date" filled hide-details offset-y
                    ></v-text-field>
                  </template>
                  <v-date-picker v-model="addUnavail.end.date.value" @input="addUnavail.end.date.picker = false" />
                </v-menu>
              </v-col>

              <v-col cols="12" sm="6">
                <v-menu v-model="addUnavail.start.time.picker" :close-on-content-click="false" transition="scale-transition" ref="menuStart">
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                        v-model="addUnavail.start.time.value" label="Heure de début" v-bind="attrs" v-on="on"
                        :rules="[$utils.rules.required]" readonly required type="time" filled hide-details offset-y
                    ></v-text-field>
                  </template>
                  <v-time-picker v-if="addUnavail.start.time.picker" v-model="addUnavail.start.time.value"
                  full-width scrollable format="24hr" @click:minute="$refs.menuStart.save(addUnavail.start.time.value)"/>
                </v-menu>
                <br>
                <v-menu v-model="addUnavail.end.time.picker" :close-on-content-click="false" transition="scale-transition" ref="menuEnd">
                  <template v-slot:activator="{ on, attrs }">
                    <v-text-field
                        v-model="addUnavail.end.time.value" label="Heure de fin" v-bind="attrs" v-on="on"
                        :rules="[$utils.rules.required]" readonly required type="time" filled hide-details offset-y
                    ></v-text-field>
                  </template>
                  <v-time-picker v-if="addUnavail.end.time.picker" v-model="addUnavail.end.time.value"
                  full-width scrollable format="24hr" @click:minute="$refs.menuEnd.save(addUnavail.end.time.value)" />
                </v-menu>
              </v-col>
            </v-row>
          </v-form>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="gray darken-4" text @click="addUnavail.dialog = false">
            Fermer
          </v-btn>
          <v-btn color="primary darken-1" text @click="addUnavailability" :loading="addUnavail.loading" :disabled="addUnavail.loading || !addUnavail.isValid">
            Ajouter
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-snackbar v-model="snackbar.success.state" :timeout="3000" color="success">
      <span>{{ snackbar.success.message }}</span>
      <template v-slot:action="{ attrs }">
        <v-btn color="white" text v-bind="attrs" @click="snackbar.success.state = false">Fermer</v-btn>
      </template>
    </v-snackbar>

    <v-snackbar v-model="snackbar.error.state" :timeout="3000" color="error">
      <span>{{ snackbar.error.message }}</span>
      <template v-slot:action="{ attrs }">
        <v-btn color="white" text v-bind="attrs" @click="snackbar.error.state = false">Fermer</v-btn>
      </template>
    </v-snackbar>

  </div>

</template>

<script>
import {mapActions, mapGetters} from "vuex";
import moment from "moment";

export default {
  name: 'Professional',
  data() {
    return {
      days: [
        {
          text: 'Lundi',
          value: 1
        },
        {
          text: 'Mardi',
          value: 2
        },
        {
          text: 'Mercredi',
          value: 3
        },
        {
          text: 'Jeudi',
          value: 4
        },
        {
          text: 'Vendredi',
          value: 5
        },
        {
          text: 'Samedi',
          value: 6
        },
        {
          text: 'Dimanche',
          value: 7
        },
      ],
      addAvail: {
        dialog: false,
        loading: false,
        isValid: false,
        days: [],
        times: ['00:00'],
        office: null,
      },
      addUnavail: {
        dialog: false,
        loading: false,
        isValid: false,
        start: {
          date: {picker: false, value: null},
          time: {picker: false, value: '08:00'}
        },
        end: {
          date: {picker: false, value: null},
          time: {picker: false, value: '19:00'}
        },
      },
      isLoading: {
        office: true,
        availabilities: true,
        unavailabilities: true,
      },
      snackbar: {
        success: {
          state: false,
          message: false,
        },
        error: {
          state: false,
          message: false,
        }
      }
    }
  },
  computed: {
    ...mapGetters(['user', 'officesOnPlaced', 'proAvailabilities', 'proUnavailabilitites']),
    validatedOffices() {
      return this.officesOnPlaced;
    },
    availabilities() {

      let res = { 1: [], 2:[], 3:[], 4:[], 5:[], 6:[], 7:[] };

      let list = this.proAvailabilities.map(availa => {
        availa.hour_start = moment(availa.hour_start, 'h:m')
        return availa;
      }).sort((a, b) => {
        return a.hour_start.isAfter(b.hour_start) ? 1 : -1;
      });

      list.forEach((availability) => {
        res[availability.day_number].push(availability)
      });

      return res;
    },
    unavailabilities() {
      return this.proUnavailabilitites;
    },
  },
  filters: {},
  methods: {
    ...mapActions(['loadCurrentUser', 'loadOfficesByPro', 'loadAvailabilities', 'loadUnavailabilitites']),
    generateOfficeColor(s) {
      s = s + "--office--" + s;
      let hash = s.split("").reduce(function (a, b) {
        a = ((a << 5) - a) + b.charCodeAt(0);
        return a & a
      }, 0) * 50
      let c = (hash & 0x00FFFFFF).toString(16).toUpperCase();
      return "#" + "00000".substring(0, 6 - c.length) + c;
    },
    addTime() {
      this.addAvail.times.push('00:00')
    },
    moment(time) {
      return moment(time);
    },

    addAvailability() {
      this.addAvail.loading = true;

      let availabilities = [];

      this.addAvail.days.forEach((dayNumber) => {
        this.addAvail.times.forEach((hour) => {
          availabilities.push({
              dayNumber: dayNumber,
              hour: hour,
              user: this.user.id,
              office: this.addAvail.office
          });
        });
      });

      this.$store.dispatch('addAvailabilities', availabilities).
      then(() => {
        this.snackbar.success.state = true;
        this.snackbar.success.message = "Disponibilités ajoutées !";
      }).
      catch(err => {
        console.log(err);
        this.snackbar.error.state = true;
        this.snackbar.error.state = "Ajout de vos disponibilités impossible :(";
      }).
      finally(() => {
        this.addAvail.loading = false;
        this.addAvail.dialog = false;
      })
    },
    removeAvailability(avail) {
      this.$store.dispatch('removeAvailability', avail.id).
      then(() => {
        this.snackbar.success.state = true;
        this.snackbar.success.message = `Disponibilité de ${avail.hour_start.format('k:m')} supprimée !`;
      }).
      catch(err => {
        console.log(err);
        this.snackbar.error.state = true;
        this.snackbar.error.state = "Suppression de ce créneau impossible !";
      })
    },

    addUnavailability() {

      let data = {
        start: moment(this.addUnavail.start.date.value + ' ' + this.addUnavail.start.time.value),
        stop: moment(this.addUnavail.end.date.value + ' ' + this.addUnavail.end.time.value),
        createdAt: moment(),
        user: this.user,
      }

      this.$store.dispatch('addUnavailabilitites', data).
      then(() => {
        this.snackbar.success.state = true;
        this.snackbar.success.message = "Indisponibilités ajoutées !";
      }).
      catch(err => {
        console.log(err);
        this.snackbar.error.state = true;
        this.snackbar.error.state = "Ajout de votre indisponibilité impossible :(";
      }).
      finally(() => {
        this.addUnavail.loading = false;
        this.addUnavail.dialog = false;
      })

    },
    removeUnavailability(unavail) {
      this.$store.dispatch('removeUnavailability', unavail.id).
      then(() => {
        this.snackbar.success.state = true;
        this.snackbar.success.message = `Indisponibilité supprimée !`;
      }).
      catch(err => {
        console.log(err);
        this.snackbar.error.state = true;
        this.snackbar.error.state = "Suppression de cette indisponibilité impossible !";
      })
    },
  },
  async mounted() {
    await this.loadCurrentUser(localStorage.getItem('token'));
    this.loadOfficesByPro(`/api/users/${this.user.id}`).then(() => this.isLoading.office = false);
    this.loadAvailabilities(this.user.id).then(() => this.isLoading.availabilities = false);
    this.loadUnavailabilitites(this.user.id).then(() => this.isLoading.unavailabilities = false);
  },
}
</script>

<style scoped lang="scss">

#disponibility-calendar-container,
#disponibility-calendar-header {
  display: flex;
  align-content: center;
  justify-content: center;
  flex-direction: row;
}

.disponibility-calendar-element,
.disponibility-calendar-header-element {
  display: flex;
  width: 100%;
  align-items: center;
  justify-content: center;
}

#disponibility-calendar-header {
  background: #13acb2;
  color: white;
  margin-bottom: 0.75rem;
  border-radius: 3px;

  .disponibility-calendar-header-element {
    font-weight: bold;
    display: flex;
    align-items: center;
    justify-content: center;
    margin-bottom: 0;
    padding: 0.75rem 0.5rem;
  }
}

#disponibility-calendar-container {
  .disponibility-calendar-row {
    display: flex;
    align-content: center;
    //justify-content: center;
    flex-direction: column;
    padding: 0.5rem;
    width: 100%;

    .disponibility-calendar-element {
      height: 50px;
      border: 2px solid transparent;
      background: gainsboro;
      border-radius: 5px;
      cursor: pointer;
      transition: .3s;
      font-weight: normal;
      color: black;

      &:hover {
        background: darken(gainsboro, 10);
        transform: scale(1.05);
      }
    }
  }
}
</style>

